Tests that use hands_setup to make a test file directory and right
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
20
3a4c683f
MP
21TMP="$scratchdir"
22FROM=${TMP}/from
23TO=${TMP}/to
3a4c683f 24LOG=${TMP}/log
3fedd74b 25RSYNC="$rsync_bin"
3a4c683f 26
2094283b 27# Berkley's nice.
96553aa7 28PATH="$PATH:/usr/ucb"
2094283b 29
3a4c683f
MP
30runtest() {
31 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
32 if eval "$2"
33 then
34 echo "${ECHO_T} done."
35 return 0
36 else
37 echo "${ECHO_T} failed!"
38 return 1
39 fi
3a4c683f
MP
40}
41
42printmsg() {
43 echo "$1"
44}
45
e052b21f 46
6773a779 47rsync_ls_lR() {
dfef3f10
MP
48 find "$@" -print | sort | xargs "$TOOLDIR/tls"
49}
50
51rsync_getgroups() {
52 "$TOOLDIR/getgroups"
57835c00
MP
53}
54
55
e052b21f
MP
56####################
57# Build test directories TO and FROM, with FROM full of files.
58
3a4c683f 59hands_setup() {
501972bf
MP
60 # Clean before creation
61 rm -rf $FROM
62 rm -rf $TO
3d807132
MP
63
64 [ -d $TMP ] || mkdir $TMP
3a4c683f
MP
65 [ -d $FROM ] || mkdir $FROM
66 [ -d $TO ] || mkdir $TO
67
e052b21f
MP
68 # On some BSD systems, the umask affects the mode of created
69 # symlinks, even though the mode apparently has no effect on how
70 # the links behave in the future, and it cannot be changed using
71 # chmod! rsync always sets its umask to 000 so that it can
72 # accurately recreate permissions, but this script is probably run
73 # with a different umask.
74
75 # This causes a little problem that "ls -l" of the two will not be
76 # the same. So, we need to set our umask before doing any creations.
77
3a4c683f
MP
78 # set up test data
79 touch ${FROM}/empty
80 mkdir ${FROM}/emptydir
e8ca5901 81
571a4b26 82 # a hundred lines of text or so
3d807132 83 rsync_ls_lR "${srcdir}" > ${FROM}/filelist
3a4c683f
MP
84
85 # This might fail on systems that don't have -n
86 echo $ECHO_N "This file has no trailing lf$ECHO_C" > ${FROM}/nolf
0154b302 87 umask 0
3a4c683f 88 ln -s nolf ${FROM}/nolf-symlink
4c80c473 89 umask 022
0154b302 90
4c80c473 91 cat $srcdir/*.c > ${FROM}/text
3a4c683f 92 mkdir ${FROM}/dir
4c80c473 93 cp ${FROM}/text ${FROM}/dir
3a4c683f
MP
94 mkdir ${FROM}/dir/subdir
95 mkdir ${FROM}/dir/subdir/subsubdir
96 ls -ltr /etc > ${FROM}/dir/subdir/subsubdir/etc-ltr-list
97 mkdir ${FROM}/dir/subdir/subsubdir2
98 ls -lt /bin > ${FROM}/dir/subdir/subsubdir2/bin-lt-list
7d691654 99
8f98c608
MP
100# echo testing head:
101# ls -lR ${srcdir} | head -10 || echo failed
7508b795
DD
102
103 # sleep here to prevent a copy from being made within the
104 # default --modify-window time on Cygwin
105 sleep 2
3a4c683f 106}
3fedd74b
MP
107
108
99cdaff7
MP
109####################
110# Many machines do not have "mkdir -p", so we have to build up long paths.
111# How boring.
112makepath () {
7c1b7890 113 echo " makepath $1"
99cdaff7
MP
114 p="$1"
115 (
116 # Absolut Unix.
117 if echo $p | grep '^/' >/dev/null
118 then
119 cd /
120 fi
121
122 # This will break if $1 contains a space.
123 for c in `echo $p | tr '/' ' '`
124 do
112e7311
MP
125 if [ -d "$c" ] || mkdir "$c"
126 then
127 cd "$c" || return $?
128 else
129 echo "failed to create $c" >&2; return $?
130 fi
99cdaff7
MP
131 done
132 )
133}
134
135
136
3fedd74b
MP
137###########################
138# Run a test (in '$1') then compare directories $2 and $3 to see if
139# there are any difference. If there are, explain them.
140
f494f286
MP
141# So normally basically $1 should be an rsync command, and $2 and $3
142# the source and destination directories. This is only good when you
143# expect to transfer the whole directory exactly as is. If some files
144# should be excluded, you might need to use something else.
145
3fedd74b 146checkit() {
3fedd74b 147 failed=
3fedd74b 148
cf72f204
MP
149 # We can just write everything to stdout/stderr, because the
150 # wrapper hides it unless there is a problem.
151
152 echo "Running: \"$1\""
153 eval "$1"
3fedd74b
MP
154 status=$?
155 if [ $status != 0 ]; then
156 failed="YES";
157 fi
158
cf72f204
MP
159 echo "-------------"
160 echo "check how the files compare with diff:"
161 echo ""
d58e4c27
MP
162 for f in `cd "$2"; find . -type f -print `
163 do
371d1c36 164 diff -c "$2"/"$f" "$3"/"$f" || failed=YES
d58e4c27
MP
165 done
166
cf72f204
MP
167 echo "-------------"
168 echo "check how the directory listings compare with diff:"
169 echo ""
170 ( cd "$2" && rsync_ls_lR . ) > ${TMP}/ls-from
171 ( cd "$3" && rsync_ls_lR . ) > ${TMP}/ls-to
172 diff -c ${TMP}/ls-from ${TMP}/ls-to || failed=YES
3fedd74b 173 if [ -z "${failed}" ] ; then
3fedd74b
MP
174 return 0
175 else
3fedd74b
MP
176 return 1
177 fi
178}
179
863dff51 180
4a7cb3e8 181build_rsyncd_conf() {
d2094cc3
MP
182 # Build an appropriate configuration file
183 conf="$scratchdir/test-rsyncd.conf"
184 echo "building configuration $conf"
185
186 port=2612
187 pidfile="$scratchdir/rsyncd.pid"
188 logfile="$scratchdir/rsyncd.log"
189
190 cat >$conf <<EOF
3aae15ec 191# rsyncd configuration file autogenerated by $0
d2094cc3 192
3aae15ec
MP
193pid file = $pidfile
194use chroot = no
195hosts allow = localhost, 127.0.0.1
196log file = $logfile
d2094cc3 197
76ee1d18
WD
198uid = 0
199gid = 0
98c1b325 200
2e6c7f45
MP
201[test-from]
202 path = $FROM
3aae15ec 203 read only = yes
d2094cc3 204
2e6c7f45
MP
205[test-to]
206 path = $TO
3aae15ec 207 read only = no
d2094cc3
MP
208EOF
209}
210
211
3cd2af41
MP
212build_symlinks() {
213 fromdir="$scratchdir/from"
214 todir="$scratchdir/to"
215 mkdir "$fromdir"
216 date >"$fromdir/referent"
217 ln -s referent "$fromdir/relative"
218 ln -s "$fromdir/referent" "$fromdir/absolute"
219 ln -s nonexistent "$fromdir/dangling"
1db8b61d 220 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
221}
222
223test_fail() {
224 echo "$@" >&2
225 exit 1
226}
227
a217ad30
MP
228test_skipped() {
229 echo "$@" >&2
7d821932 230 echo "$@" > "$TMP/whyskipped"
a217ad30
MP
231 exit 77
232}
233
be2f866b
MP
234# It failed, but we expected that. don't dump out error logs,
235# because most users won't want to see them. But do leave
236# the working directory around.
237test_xfail() {
238 echo "$@" >&2
239 exit 78
240}
241
d1239eae
MP
242# Determine what shell command will appropriately test for links.
243ln -s foo "$scratchdir/testlink"
244for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
245do
246 for switch in -h -L
247 do
248 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
249 then
250 # how nice
251 TEST_SYMLINK_CMD="$cmd $switch"
252 # i wonder if break 2 is portable?
253 break 2
254 fi
255 done
256done
cca4e067
MP
257# ok, now get rid of it
258rm "$scratchdir/testlink"
d1239eae
MP
259
260
261if [ "x$TEST_SYMLINK_CMD" = 'x' ]
262then
263 test_fail "Couldn't determine how to test for symlinks"
264else
265 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
266fi
267
268
d96d3893
MP
269# Test whether something is a link, allowing for shell peculiarities
270is_a_link() {
d1239eae
MP
271 # note the variable contains the first option and therefore is not quoted
272 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
273}
274
77867907
MP
275
276# We need to set the umask to be reproducible. Note also that when we
277# do some daemon tests as root, we will setuid() and therefore the
278# directory has to be writable by the nobody user in some cases. The
279# best thing is probably to explicitly chmod those directories after
280# creation.
281
ad301e48 282umask 022